
header_inject_head=$(cat <<EOF
<script type="text/javascript" src="/js/webif.js"></script>
<script type="text/javascript">
/* <![CDATA[ */

function webif_entityDecode(s) {
    var e = document.createElement("div");
    e.innerHTML = s;
    return e.firstChild.nodeValue;
}

var webif_printf=function() {
	var num = arguments.length;
	var output = arguments[0];
	for (var i = 1; i < num; i++) {
		var pattern = "\\\\{" + (i-1) + "\\\\}";
		var re = new RegExp(pattern, "g");
		output = output.replace(re, arguments[i]);
	}
	return output;
}

function confirm_deldir(path,file) {
	if (window.confirm(webif_entityDecode(webif_printf("WARNING!\\n\\nDo you really want to delete the '{0}' directory?", file)))) {
		window.location="$SCRIPT_NAME?path=" + encodeURIComponent(path) + "&delpath=" + encodeURIComponent(file);
	}
}
function confirm_delfile(path,file) {
	if (window.confirm(webif_entityDecode(webif_printf("WARNING!\\n\\nDo you really want to delete the '{0}/{1}' file?", path, file)))) {
		window.location="$SCRIPT_NAME?path=" + encodeURIComponent(path) + "&delfile=" + encodeURIComponent(file);
	}
}

function statusupdate() {
	document.getElementById("form_submit").style.display = "none";

	return true;
}

function fix_uris()
{
	
}

function printStatus() {
	document.write('<div style="display: none; font-size: 14pt; font-weight: bold;" id="status_text" />Uploading...&nbsp;</div>');
}

function statusupdate() {
	document.getElementById("form_submit").style.display = "none";
	document.getElementById("status_text").style.display = "inline";
	
	return true;
}

function confirm_delapp(path,file,appname) {
	if (window.confirm(webif_entityDecode(webif_printf("WARNING!\\n\\nDo you really want to delete the '{0}' application?", appname)))) {
		window.location="$SCRIPT_NAME?path=" + encodeURIComponent(path) + "&delapp=" + encodeURIComponent(file) + "&delapp_name=" + encodeURIComponent(appname);
	}
}

/* ]]> */
</script>

EOF
)

############################
# deleters
############################

! empty "$FORM_delapp" && {
	load_settings ua_$FORM_delapp_name
	$SBC_CONFIGDIR/init.d/S$app_priority$FORM_delapp_name stop 2>&1 >/dev/null
	sleep 2
	cd / 2>/dev/null
	ERROR=$(rm -rf $FORM_delapp $SBC_CONFIGDIR/init.d/S??$FORM_delapp_name $SBC_CONFIGDIR/ua_$FORM_delapp_name.conf)
	equal "$?" "0" && {
		MESSAGE=$(cat <<EOF
Application was deleted successfully:<br/>
<strong>$FORM_delapp_name</strong><br/><br/>
EOF
)
	}
}

! empty "$FORM_delpath" && {
	cd / 2>/dev/null
	ERROR=$(rmdir "$FORM_delpath" 2>&1)
	equal "$?" "0" && {
		MESSAGE=$(cat <<EOF
Directory was deleted successfully:<br/>
<strong>$FORM_delpath</strong>
EOF
)
	}
}

! empty "$FORM_delfile" && {
	ERROR=$(rm "$FORM_path/$FORM_delfile" 2>&1)
	equal "$?" "0" && {
		MESSAGE=$(cat <<EOF
File was deleted successfully:<br/>
<strong>$FORM_path/$FORM_delfile</strong>
EOF
)
	}
}

############################
# fix path
############################

FORM_path="${FORM_path:-/}"
ERROR="$ERROR$(cd "$FORM_path" 2>&1)"
cd "$FORM_path" 2>/dev/null
while [ "$?" != "0" ]; do
	FORM_path="${FORM_path%/*}"
	FORM_path="${FORM_path:-/}"
	cd "$FORM_path" 2>/dev/null
done
FORM_path="$(pwd)"

# return to the cgi dir
cd "${SCRIPT_NAME%/*}" 2>/dev/null

############################
# directory was created
############################
if ! equal "$FORM_dirname" ""; then
	validate <<EOF
filedir|FORM_dirname|Directory Name|required min=1 max=63|$FORM_dirname
EOF
	if equal "$?" 0 ; then
		#strip any path info - just want the filename
		filename="${FORM_file_name##*\\}"
		filename="${filename##*/}"
		if [ -e "$FORM_path/$FORM_dirname" ]; then
			ERROR="Error creating directory $FORM_dirname - a file or directory of the same name already exists."
		else
			if mkdir "$FORM_path/$FORM_dirname" && chown root:root "$FORM_path/$FORM_dirname"; then
				MESSAGE="Directory was created successfully:<br/><strong>$FORM_dirname</strong>"
			else
				ERROR="Error creating directory $FORM_dirname"
			fi
		fi
	fi
	
fi

############################
# file was uploaded
############################
if ! equal "$FORM_file" ""; then
	#strip any path info - just want the filename
	filename="${FORM_file_name##*\\\\}"
	filename="${FORM_file_name##*\\}"
	filename="${filename##*/}"
	
	validate <<EOF
filedir|filename|File Name|required min=1 max=63|$filename
EOF

	if equal "$?" 0 ; then
		fsize=$(ls -alL "$FORM_file" 2>/dev/null | awk '{ print $5 }')
		freespace_bytes=$(df / | grep / | awk {'print $4*1024'})
		if [ "$fsize" -gt "$freespace_bytes" ]; then
			ERROR="Error recieving file $filename - not enough free space"
			rm "$FORM_file"
		elif [ -e "$FORM_path/$filename" ]; then
			ERROR="Error recieving file $filename - a file or directory of the same name already exists."
			rm "$FORM_file"
		else
			if mv "$FORM_file" "$FORM_path/$filename" && chown root:root "$FORM_path/$filename"; then
				MESSAGE="File was uploaded successfully:<br/><strong>$filename</strong>"
			else
				ERROR="Error recieving file $filename"
				rm "$FORM_file"
			fi
		fi
	else
		rm "$FORM_file"
	fi
fi

############################
# save
# Note that we remove all cariage returns (/r)
# Windows browsers try to save in windows format - /r/n
# but this messes up unix where we expect just /n
############################

freespace=$(df -h / | grep / | awk {'print $4'})
edit_pathname="$FORM_path/$FORM_edit"
saved_filename="/tmp/.webif/edited-files$edit_pathname"

! empty "$FORM_save" && {
	mkdir -p "/tmp/.webif/edited-files$FORM_path"
	cat > "$saved_filename".tmp <<EOFladalllfeovn
$FORM_filecontent
EOFladalllfeovn
	tr -d '\015' < "$saved_filename".tmp > "$saved_filename"
	rm -f "$saved_filename".tmp
	apply_saves
}

! empty "$FORM_savecommit" && {
	rm -f "$saved_filename"
	MESSAGE="File was saved successfully:<br/><strong>$edit_pathname</strong>"
	cat > "$edit_pathname".tmp <<EOFladalllfeovn
$FORM_filecontent
EOFladalllfeovn
	tr -d '\015' < "$edit_pathname".tmp > "$edit_pathname"
	rm -f "$edit_pathname".tmp
	sync
}


empty "$FORM_cancel" || FORM_edit=""
