# WARNING! the input list must be sorted with directories first
BEGIN {
	gsub(/^\/\//, "/", path)
	print "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">"
	print "<tr>"
	print "  <td class=\"listtopic\">Filesystem Browser: <a href=\"javascript:window.location='" url "?path='+encodeURIComponent('" escape_apostrophes(path) "');\">" path "</a></td>"
	print "</tr>"
	print "<tr>"
	print "<td>"
	print "<table class=\"filebrowser\" width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">"
	print "<tr>"
	print "<td style=\"width:27px; vertical-align:middle\" class=\"listl\"><a href=\"" url "?path=/\"><img src=\"/images/dir.gif\" alt=\"\" /></a></td>"
	print "<td class=\"listn\"><a href=\"" url "?path=/\">Root</a></td>"
	print "<td class=\"listn\">&nbsp;</td><td style=\"width:60px;\" class=\"listr\">&nbsp;</td>"
	print "</tr>"
	# do not let the user to make wrong things (hm, at least some of them)
	xdirectory="^(/bin$|/bin/$|/dev$|/dev/.*$|/etc$|/jffs$|/lib$|/lib/modules$|/lib/modules/.*$|/mnt$|/proc$|/proc/.*$|/rom$|/rom/.*$|/sbin$|/sys$|/sys/.*$|/usr$|/usr/bin$|/usr/lib$|/usr/lib/webif$|/usr/sbin$|/usr/share$|/var/www$|/var/www/.*$|/var/www/themes/.*$|/var/www/cgi-bin$)"
	xdownload="^(/dev$|/dev/.*$|/proc$|/proc/.*$|/sys$|/sys/.*$)"
	xedit="^(/dev$|/dev/.*$|/lib$|/lib/modules/.*$|/proc$|/proc/.*$|/rom$|/rom/.*$|/sys$|/sys/.*$)"
	xdelete="^(/dev$|/dev/.*$|/lib$|/lib/modules/.*$|/proc$|/proc/.*$|/rom$|/rom/.*$|/sys$|/sys/.*$|/var/www/.*$)"
}


function escape_apostrophes(line)
{
	if(index(line, "'") > 0)
	{
		while ( sub(/'/, "MY SPECIAL ESCAPE VAL", line) > 0 ) ;
		while ( sub(/MY SPECIAL ESCAPE VAL/, "\\'", line) > 0 ) ;
	}
	return line;
}

{
	type = substr($1, 1, 1);
	fname = $11
	for (i = 12; i <= NF; i++)
		fname = fname " " $i
	line = ""
	fullpath = path "/" fname
	gsub(/^\/\//, "/", fullpath)
}

(fname != ".") && (fname != "") {
	print "<tr>"
	finfo = "Permissions: " substr($1,2) "<br />Owner: " $3 "<br />Group: " $4 "<br />Time: " $6
	for (i=7; i<=10; i++) finfo = finfo " " $i
}

type == "d" {
	if (fname == "..") {
		fullpath = path "/.."
		gsub(/^\/\//, "/", fullpath)
		print "<td style=\"vertical-align:middle\" class=\"listl\"><a href=\"javascript:window.location='" url "?path='+encodeURIComponent('" escape_apostrophes(fullpath) "');\"><img src=\"/images/dir.gif\" alt=\"Parent Directory\" /></a></td>"
		print "<td class=\"listn\"><a href=\"javascript:window.location='" url "?path='+encodeURIComponent('" escape_apostrophes(fullpath) "');\">Parent Directory</a></td>"
		print "<td class=\"listn\">&nbsp;</td>"
		print "<td class=\"listr\">&nbsp;</td>"
	} else if (fname != ".") {
		print "<td style=\"vertical-align:middle\" class=\"listl\"><a class=\"tooltip\" href=\"javascript:window.location='" url "?path='+encodeURIComponent('" escape_apostrophes(fullpath) "');\"><img src=\"/images/dir.gif\" alt=\"Directory\" /><span style=\"text-align:left\" class=\"tooltip\">" finfo "</span></a></td>"
		print "<td class=\"listn\"><a href=\"javascript:window.location='" url "?path='+encodeURIComponent('" escape_apostrophes(fullpath) "');\">" fname "</a></td>"
		print "<td class=\"listn\">&nbsp;</td>"
		if (fullpath ~ xdirectory) {
			print "<td style=\"text-align:right\" class=\"listr\"><img src=\"/images/action_x_no.gif\" alt=\"Delete\" /></td>"
		} else {
			print "<td style=\"text-align:right\" class=\"listr\"><a href=\"javascript:confirm_deldir('" escape_apostrophes(path)  "','" escape_apostrophes(fullpath) "')\"><img src=\"/images/action_x.gif\" alt=\"Delete\" /></a></td>"
		}
	}
}

type == "-" {
	print "<td style=\"vertical-align:middle\" class=\"listl\"><a class=\"tooltip\" href=\"javascript:window.location='/cgi-bin/download?script=" url "&amp;path='+encodeURIComponent('" escape_apostrophes(path) "')+'&amp;savefile='+encodeURIComponent('" escape_apostrophes(fname) "');\"><img src=\"/images/file.gif\" alt=\"File\" /><span style=\"text-align:left\" class=\"tooltip\">" finfo "</span></a></td>"
	if (path ~ xdownload) {
		print fname "<td class=\"listn\">$nbsp;</td>"
	} else {
		print "<td class=\"listn\"><a href=\"javascript:window.location='/cgi-bin/download?script=" url "&amp;path='+encodeURIComponent('" escape_apostrophes(path) "')+'&amp;savefile='+encodeURIComponent('" escape_apostrophes(fname) "');\">" fname "</a></td>"
	}
	printf "<td style=\"text-align:right\" class=\"listn\">"
	if ($5 >= 2^30) {
		printf "%.1f GB", $5 / (2^30)
	} else if ($5 >= 2^20) {
		printf "%.1f MB", $5 / (2^20)
	} else if ($5 >= 2^15) {
		printf "%.1f kB", $5 / (2^10)
	} else {
		printf "%d Bytes", $5
	}
	print "</td>"
	if ((path ~ xedit) || $5 >= 2^16) {
		print "<td style=\"text-align:right\" class=\"listr\"><img src=\"/images/action_edit_no.gif\" alt=\"Edit\" />"
	} else {
		print "<td style=\"text-align:right\" class=\"listr\"><a href=\"javascript:window.location='" url "?path='+encodeURIComponent('" escape_apostrophes(path) "')+'&amp;edit='+encodeURIComponent('" escape_apostrophes(fname) "');\"><img src=\"/images/action_edit.gif\" alt=\"Edit\" /></a>"
	}
	if (path ~ xdelete) {
		print "<img src=\"/images/action_x_no.gif\" alt=\"Delete\" /></td>"
	} else {
		print "<a href=\"javascript:confirm_delfile('" escape_apostrophes(path)  "','" escape_apostrophes(fname) "')\"><img src=\"/images/action_x.gif\" alt=\"Delete\" /></a></td>"
	}
}

(fname != ".") && (fname != "") {
	print "</tr>"
}

END {
	print "</table></td></tr></table>"
}
